Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Reflection

Module Functions
    Public Function CheckPCDProcess() As Boolean
        Dim ProcPcd() As Process = Process.GetProcessesByName("PCDLRN")
        If ProcPcd.Length > 0 Then
            Return True
        Else
            Return False
        End If
    End Function
    Public Sub KillPcd()
        Dim ProcPcd() As Process = Process.GetProcessesByName("PCDLRN")
        Dim ProcCount As Integer = ProcPcd.Length - 1
        Try
            For I As Integer = ProcCount To 0 Step -1
                ProcPcd(I).Kill()
            Next
        Catch ex As Exception
        End Try

    End Sub

    Public Function CheckTutProcess() As Boolean
        Dim ProcTut() As Process = Process.GetProcessesByName("TutoRun")
        If ProcTut.Length > 0 Then
            Return True
        Else
            Return False
        End If
    End Function
    Public Function IsTutControllable() As Boolean
        Dim TutApp As TutoRun.TutoRunMain
        Dim TutDNC As TutoRun.TutoRunDnc

        Dim TutHandle As Integer
        TutApp = CreateObject("TutoRun.TutoRunMain")
        TutDNC = TutApp.Dnc
        TutHandle = TutDNC.GetFullAppTutorControl(0)
        TutDNC.ReleaseFullApplTutorControl(TutHandle)
        TutDNC = Nothing
        TutApp = Nothing

        If TutHandle > 0 Then
            Return True
        Else
            Return False
        End If
    End Function
    Public Sub KillTut()
        Dim ProcTut() As Process = Process.GetProcessesByName("TutoRun")
        Dim ProcCount As Integer = ProcTut.Length - 1
        Try
            For I As Integer = ProcCount To 0 Step -1
                ProcTut(I).Kill()
            Next
        Catch ex As Exception
        End Try
    End Sub

    Public Function CheckProcess(ByVal AppName As String) As Boolean
        'Verifica se  in esecuzione l'applicazione Pcdmis
        Try
            Dim Proc() As Process = Process.GetProcessesByName(AppName)
            If Proc.Length >= 1 Then
                Return True
            Else
                Return False
            End If
        Catch ProcessErr As SystemException
            'TODO: Gestire le eccezioni
        End Try
    End Function
    Public Function KillProcess(ByVal AppName As String, ByVal BruteForce As Boolean) As Boolean
        'Verifica se  in esecuzione l'applicazione passata come parametro e la termina.
        ' Il secondo parametro determina se applicare una procedura di chiusura BruteForce
        Try
            Dim Proc() As Process = Process.GetProcessesByName(AppName)
            If Proc.Length >= 1 Then
                Select Case BruteForce
                    Case False
                        Do While Proc.Length > 0
                            Dim ProcIndex = Proc.Length
                            KillProcess = Proc(ProcIndex - 1).CloseMainWindow
                            Proc(ProcIndex - 1).Close()
                            GC.Collect()
                        Loop
                    Case True
                        Do While Proc.Length = 0
                            Dim ProcIndex = Proc.Length
                            Proc(ProcIndex - 1).Kill()
                        Loop
                End Select
                Return True
            Else
                Return False
            End If
        Catch ProcessErr As SystemException
            'TODO: Gestire le eccezioni
        End Try
    End Function
    Public Sub SerializeToFile(ByVal path As String, ByVal obj As Object)
        ' Open the stream for output.
        Try

            Using fs As New FileStream(path, FileMode.Create)
                ' Create a formatter for this file stream.
                Dim bf As New BinaryFormatter(Nothing, New StreamingContext(StreamingContextStates.File))
                ' Serialize the object and close the stream.
                bf.Serialize(fs, obj)
            End Using

        Catch ex As Exception

        End Try

    End Sub

    Public Function DeserializeFromFile(ByVal path As String) As Object
        ' Open the stream for input.
        Try
            Using fs As New FileStream(path, FileMode.Open)
                ' Create a formatter for this file stream.
                Dim bf As New BinaryFormatter(Nothing, New StreamingContext(StreamingContextStates.File))
                ' Deserialize the object from the stream.
                Return bf.Deserialize(fs)
            End Using

        Catch ex As Exception
            Return False
        End Try

    End Function


    Public Function Bool2OnOff(ByVal Value As Boolean) As String
        If Value Then
            Return "On"
        Else
            Return "Off"
        End If
    End Function

    Public Function Bool2String(ByVal Value As Boolean) As String
        If Value Then
            Return "True"
        Else
            Return "False"
        End If
    End Function



    Friend Sub WriteToLog(ByVal msg As String)
        'Me.txbStato.Text = msg
    End Sub



    Friend Function ValidaNullDBValue(ByVal frm As Form, ByVal ErPr As ErrorProvider, ByVal cntr As Control) As Boolean

        Dim TagValue As Integer = CInt(ErPr.Tag.ToString)

        Select Case cntr.GetType.Name
            Case "TextBox"
                Dim tb As TextBox = DirectCast(cntr, TextBox)

                If String.IsNullOrEmpty(tb.Text) Then
                    ErPr.SetError(cntr, "Il valore non pu essere nullo. Inserire un valore per il campo")
                    TagValue += 1
                Else
                    ErPr.SetError(cntr, "")
                    If TagValue > 0 Then TagValue -= 1
                End If

            Case "ComboBox"
                Dim cb As ComboBox = DirectCast(cntr, ComboBox)

                If String.IsNullOrEmpty(cb.Text) Then
                    ErPr.SetError(cntr, "Il valore non pu essere nullo. Inserire un valore per il campo")
                    TagValue += 1
                Else
                    ErPr.SetError(cntr, "")
                    If TagValue > 0 Then TagValue -= 1
                End If
        End Select

        ErPr.Tag = CObj(TagValue)

        Return TagValue = 0

    End Function

    Friend Function ValidaPath(ByVal frm As Form, ByVal ErPr As ErrorProvider, ByVal cntr As Control) As Boolean

        Dim TagValue As Integer = CInt(ErPr.Tag.ToString)

        Select Case cntr.GetType.Name
            Case "TextBox"
                Dim tb As TextBox = DirectCast(cntr, TextBox)

                If Not String.IsNullOrEmpty(tb.Text) Then
                    If Not File.Exists(tb.Text) Then
                        ErPr.SetError(cntr, "Il file specificato non esiste. Specificare un percorso valido")
                        TagValue += 1
                    End If
                Else
                    ErPr.SetError(cntr, "")
                    If TagValue > 0 Then TagValue -= 1
                End If
            Case "ComboBox"
                Dim cb As ComboBox = DirectCast(cntr, ComboBox)

                If Not String.IsNullOrEmpty(cb.Text) Then
                    If Not File.Exists(cb.Text) Then
                        ErPr.SetError(cntr, "Il file specificato non esiste. Specificare un percorso valido")
                        TagValue += 1
                    Else
                        ErPr.SetError(cntr, "")
                        If TagValue > 0 Then TagValue -= 1
                    End If
                End If
        End Select

        ErPr.Tag = CObj(TagValue)

        Return TagValue = 0

    End Function

    Public Function GetFields(ByRef tb As DataTable) As String()
        Dim res As New ArrayList

        With tb
            res.Clear()
            'res.Add("")
            For Each col As DataColumn In .Columns
                res.Add(col.ColumnName)
            Next
        End With

        res.Sort()

        Return DirectCast(res.ToArray(GetType(String)), String())
    End Function

    Public Function GetValue(ByRef tb As DataTable, ByVal Filtro As String, ByVal Sort As Boolean, ByVal col As String, Optional ByVal SecondCol As String = "") As String()
        Dim res As New ArrayList

        Try
            With tb

                Dim rr As DataRow() = tb.Select(Filtro)

                res.Clear()
                'res.Add("")
                For Each row As DataRow In rr '.Rows
                    Try
                        Dim val As Object

                        If Not SecondCol = "" Then
                            val = row(col) & "|" & row(SecondCol)
                        Else
                            val = row(col)
                        End If

                        Dim FormatData As DateTime
                        If Date.TryParse(val, FormatData) Then
                            val = FormatData.ToShortDateString
                        End If
                        If Not String.IsNullOrEmpty(val) Then

                            Dim i As Integer = res.IndexOf(val)

                            If i = -1 Then res.Add(val)
                        End If
                    Catch
                    End Try

                Next
            End With

            If Sort Then res.Sort()

            Return DirectCast(res.ToArray(GetType(String)), String())

        Catch EX As Exception
            Return Nothing
        End Try

    End Function

    Public Function CercaCampoEsistente(ByVal Campo As String, ByVal Filtro As String) As Boolean

        Return Filtro.Contains(Campo)

    End Function

    Public Function AggiornaCampo(ByVal Campo As String, ByVal Valore As String, ByVal Filtro As String) As String

        Dim DividiFiltro As String() = Filtro.Split("|")

        Filtro = String.Empty

        For I As Integer = 0 To DividiFiltro.Length - 1
            Dim DividiCampo As String() = DividiFiltro(I).Split(New String() {"="}, StringSplitOptions.None)

            If DividiCampo.Length > 1 AndAlso DividiCampo(0).Contains(Campo) Then
                If DividiCampo(0).Contains("And") Then Filtro += " And "
                Filtro += CalcolaNuovoCampo(Campo, Valore)
            Else
                If Not String.IsNullOrEmpty(DividiFiltro(I)) Then
                    'If DividiCampo(0).Contains("And") Then Filtro += " And "
                    Filtro += DividiFiltro(I) & "|"
                End If

            End If
        Next

        Return Filtro
    End Function

    Public Function AggiungiCampo(ByVal Campo As String, ByVal Valore As String, ByVal Filtro As String) As String

        If Not String.IsNullOrEmpty(Filtro) Then Filtro += "And "
        Filtro += CalcolaNuovoCampo(Campo, Valore)

        Return Filtro
    End Function

    Public Function CalcolaNuovoCampo(ByVal Campo As String, ByVal Valore As String) As String
        Dim ValoreData As Date
        Dim IsDate As Boolean = Date.TryParse(Valore, ValoreData)

        If IsDate Then
            Return String.Format("[{0}] >= #{1}# AND [{0}] < #{2}#|", Campo, ValoreData, ValoreData.AddDays(1).AddSeconds(-1))
        Else
            Return String.Format("[{0}] = '{1}'|", Campo, Valore)
        End If
    End Function
End Module
