
Public Class TutorService
    Implements IDisposable
    Private WithEvents TutDNC As TutoRun.TutoRunDnc
    Private TutApp As TutoRun.TutoRunMain
    Private TutEvent As TutoRun.TutoRunEvent
    Private CMMStatus As TutoRun.CmmStatus
    Private TutStatus As TutoRun.ActType

    Public TutStart As Boolean
    Private TutHandle As Integer
    Private F_PowerOn As Boolean
    Private F_HomeCMM As Boolean
    Private F_HomePH As Boolean
    Private F_PH9Present As Boolean
    Private Zeroes As Boolean
    Private PPLoad As Boolean
    Private m_CheckError As Boolean
    Private m_CheckCancel As Boolean
    Private m_EndExec As Boolean

    Delegate Sub SendMessage(ByVal msg As String)
    'Dim sMsg As SendMessage


#Region "Gestione Servizi Tutor"
    Public Property CheckCancel() As Boolean
        Get
            Return m_CheckCancel
        End Get
        Set(ByVal value As Boolean)
            m_CheckCancel = value
        End Set
    End Property
    Public ReadOnly Property CheckError() As Boolean
        Get
            Return m_CheckError
        End Get
    End Property

    Public Property EndExec() As Boolean
        Get
            Return m_EndExec
        End Get
        Set(ByVal value As Boolean)
            m_EndExec = value
        End Set
    End Property

    Private Sub TutDNC_DncEvent(ByVal eve As TutoRun.TutoRunEvent) Handles TutDNC.DncEvent
        Select Case eve.Type
            Case TutoRun.EventType.TutorPowerOnEnd
                Debug.Print("PowerOn terminato" & Now)
                GetKernelStatus()
                F_PowerOn = True
            Case TutoRun.EventType.TutorPowerOffEnd
                Debug.Print("PowerOn terminato" & Now)
                GetKernelStatus()
                F_PowerOn = False
            Case TutoRun.EventType.TutorHomeCmmEnd
                Debug.Print("HomeCMM terminato" & Now)
                GetKernelStatus()
                F_HomeCMM = True
            Case TutoRun.EventType.TutorHomePh9End
                Debug.Print("HomePH terminato" & Now)
                F_HomePH = True
                GetKernelStatus()
            Case TutoRun.EventType.TutorLoadProgEnd
                Debug.Print("Caricamento Programma terminato" & Now)
                PPLoad = True
            Case TutoRun.EventType.TutorRunReqEnd
                Debug.Print("Esecuzione Terminata TutorRunReqEnd" & Now)
                'EndExec = True
            Case TutoRun.EventType.TutorProgExecEnd
                Debug.Print("Esecuzione terminata TutorProgExecEnd" & Now)
                'm_CheckCancel = False
                'm_CheckError = False
                'EndExec = True
            Case TutoRun.EventType.TutorExecutionEnd
                Dim EndType As TutoRun.IEndExecEvent = eve
                If EndType.ExecStatus = TutoRun.ExecutionStatus.ExecutionAbortStatus Then
                    Dim Scelta As MsgBoxResult = MsgBox("Vuoi interrompere la coda di esecuzione?", MsgBoxStyle.YesNo + MsgBoxStyle.MsgBoxSetForeground, "TutoRun - Esecuzione interrotta dall'utente")
                    If Scelta = MsgBoxResult.Yes Then
                        CheckCancel = True
                    Else
                        CheckCancel = False
                    End If
                    m_CheckError = True
                ElseIf EndType.ExecStatus = (TutoRun.ExecutionStatus.ExecutionUnknownErrorsStatus Or TutoRun.ExecutionStatus.ExecutionChainErrorsStatus Or TutoRun.ExecutionStatus.ExecutionComputingErrorsStatus Or TutoRun.ExecutionStatus.ExecutionInterpreterErrorsStatus) Then
                    m_CheckError = True
                End If
                GetKernelStatus()
                EndExec = True
            Case TutoRun.EventType.TutorAbortReqEnd
                    m_CheckCancel = True
                    m_CheckError = False
            Case TutoRun.EventType.TutorFailureOn
                    m_CheckError = True
                    m_CheckCancel = False
        End Select
    End Sub
    Sub TutorStart()
        'Avvia TutoRun
        '--- AM  sMsg = New SendMessage(AddressOf WriteToStato)

        Try
            If IsNothing(TutApp) Then
                TutApp = CreateObject("TutoRun.TutoRunMain")
                TutDNC = TutApp.Dnc
                TutStart = True
                TutStatus = TutDNC.RegisterStatus(TutoRun.ActType.AppActive)
                TutHandle = TutDNC.GetFullAppTutorControl(0)
                F_PH9Present = TutDNC.Ph9Present

                'sMsg.Invoke(String.Format("{0}: TutStatus= {1} TutHandle = {2}", Now, TutStatus, TutHandle))
                Application.DoEvents()
                GetKernelStatus()
            End If
        Catch ex As Exception
            'sMsg("Errore TutorStart : " & ex.Message)
        End Try
    End Sub

    Sub GetKernelStatus()
        Dim Wts As TutoRun.KernelStatus
        Dim status As Long
        Try


            TutStatus = TutDNC.TutorStatus
            If (TutStatus <> TutoRun.ActType.TutorInactive) And (TutHandle > 0) Then
                Wts = New TutoRun.KernelStatus
                status = TutDNC.GetKernelStatus(Wts)
                F_PowerOn = Wts.PowerOn
                F_HomeCMM = Wts.HomeCmm
                If F_PH9Present Then
                    F_HomePH = Wts.HomePh9
                Else
                    F_HomePH = True
                End If
                'sMsg.Invoke(CStr(Now & ": F_HomePH  = " & F_HomePH))
                Zeroes = (F_HomeCMM And F_HomePH)
                PPLoad = Wts.PPLoad
                CMMStatus = Wts.cmmStat

                Wts = Nothing
            End If

            'sMsg.Invoke(String.Format("{0}: PowerOn = {1} - HomeCMM = {2} - HomePH= {3} - Zeroes= {4} - PPLoad= {5} - CMMStatus= {6}", Now, F_PowerOn, F_HomeCMM, F_HomePH, Zeroes, PPLoad, CMMStatus))
        Catch ex As Exception
            'sMsg.Invoke(ex.Message)

        End Try
    End Sub
    Public Sub PowerOn()
        'Avvia TutoRun e rileva lo stato del kernel
        Dim status As Long
        If Not IsNothing(TutDNC) And (TutHandle > 0) Then
            'sMsg.Invoke(CStr(Now & ": TutStatus = " & TutStatus))
            Me.GetKernelStatus()
        End If

        If (TutHandle > 0) And (Not F_PowerOn) Then
            status = TutDNC.PowerOn(TutHandle)
            Do
                Application.DoEvents()
                System.Threading.Thread.Sleep(100)
                GetKernelStatus()
            Loop Until F_PowerOn
        End If
    End Sub

    Public Sub HomeCMM()
        Dim status As Long
        If Not IsNothing(TutDNC) Then
            GetKernelStatus()
            If (TutHandle > 0) And (F_PowerOn) And Not F_HomeCMM Then
                status = TutDNC.Zeroes(TutHandle, TutoRun.HomeMode.CmmOnly)
                Do
                    Application.DoEvents()
                    System.Threading.Thread.Sleep(100)
                    GetKernelStatus()
                Loop Until F_HomeCMM
            End If
        End If
    End Sub

    Public Sub HomePH()
        Dim status As Long
        If Not IsNothing(TutDNC) Then
            GetKernelStatus()
            If (TutHandle > 0) And Not (F_HomePH) Then
                status = TutDNC.Zeroes(TutHandle, TutoRun.HomeMode.Ph9Only)
                'sMsg.Invoke(CStr(Now & ": Status HomePH= " & status))
                Do
                    Application.DoEvents()
                    System.Threading.Thread.Sleep(100)
                    GetKernelStatus()
                Loop Until F_HomePH
            End If
        End If

    End Sub
#End Region
    Public Sub PowerOff()
        'Avvia TutoRun e rileva lo stato del kernel
        Dim status As Long
        If Not IsNothing(TutDNC) And (TutHandle > 0) Then
            'sMsg.Invoke(CStr(Now & ": TutStatus = " & TutStatus))
            Me.GetKernelStatus()
        End If
        If (TutHandle > 0) And (F_PowerOn) Then
            status = TutDNC.PowerOff(TutHandle)
        End If
    End Sub
    Public Sub TutorStop()
        If Not IsNothing(TutApp) Then
            TutDNC = Nothing
            TutApp = Nothing
            Dispose()
        End If
        GC.Collect()
    End Sub

    Sub LoadProgram(ByVal fn As String)
        Dim status As Long
        If Not IsNothing(TutDNC) Then
            GetKernelStatus()
            If (TutHandle > 0) And Zeroes Then
                PPLoad = False
                status = TutApp.Dnc.LoadProgram(TutHandle, fn)
                'sMsg.Invoke("Inizio Apertura file: " & status & " @ " & Date.Now.ToString)
                Do
                    Application.DoEvents()
                    System.Threading.Thread.Sleep(100)
                    GetKernelStatus()
                Loop Until PPLoad = True
                'Creazione File indice pallet
                '-- AM FileIO.FileSystem.WriteAllText(My.Settings.FileRicAllTut, CStr(task.IndiceAttrezzo) & Constants.vbCrLf, False, System.Text.Encoding.ASCII)
            End If
        End If
    End Sub
    Sub RunProgram()
        Dim RunStatus As Long

        If Not IsNothing(TutDNC) Then
            GetKernelStatus()
            If (TutHandle > 0) And PPLoad Then
                EndExec = False
                m_CheckCancel = False
                m_CheckError = False
                'sMsg.Invoke("Inizio esecuzione @ " & Date.Now.ToString)
                RunStatus = TutApp.Dnc.RunPartProgram(TutHandle, TutoRun.RunStartMode.RunContinue)
                Do
                    Application.DoEvents()
                    System.Threading.Thread.Sleep(100)
                    GetKernelStatus()
                Loop Until EndExec = True

                'sMsg.Invoke("Fine esecuzione @ " & Date.Now.ToString)
            End If
        End If
    End Sub
    Public Sub StopExec()
        If (TutHandle > 0) And PPLoad Then
            TutDNC.AbortPartProgram(TutHandle)
        End If
    End Sub
    Private disposedValue As Boolean = False        ' Per rilevare chiamate ridondanti
    ' IDisposable
    Protected Overridable Sub Dispose(ByVal disposing As Boolean)
        If Not Me.disposedValue Then
            If disposing Then
                ' TODO: liberare le risorse non gestite chiamate in modo esplicito
            End If
            ' TODO: liberare le risorse non gestite condivise
        End If
        Me.disposedValue = True
    End Sub

#Region " IDisposable Support "
    ' Questo codice  aggiunto da Visual Basic per implementare in modo corretto il modello Disposable.
    Public Sub Dispose() Implements IDisposable.Dispose
        ' Non modificare questo codice. Inserire il codice di pulitura in Dispose(ByVal disposing As Boolean).
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub
 
  
#End Region
End Class



